import javax.swing.*;
import javax.swing.table.*;
import javax.swing.border.*;

import java.awt.Dimension;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.Color;
import java.awt.*;

import java.util.ArrayList;


// Tabelle mit einer Klasse
// Listener in der Spalte der U-Nummern
// zeilenweise highlight, bActivate
// Klasse item kapselt den Eintrag mit bActivate

public class Tabelle06 extends JFrame {


   ArrayList<Student> liste = new ArrayList<>();
   JTable tabelle;

   final String[]
   names = {"Vorname", "Nachname", "MatrNr", "UNumer", "Farbe"};

  public Tabelle06() {
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    setLocation(100,100);
    this.setSize(550, 350);
    this.setTitle("Tabelle06");
    setGUI();
  }


    private void setGUI() {
      setdata(); // erstellt den Vector und fllt ihn
      tabelle = createTable();
      JScrollPane scrollpane = new JScrollPane(tabelle);
      scrollpane.setBorder(new BevelBorder(BevelBorder.LOWERED));
      scrollpane.setPreferredSize(new Dimension(430, 200));
      this.getContentPane().add(scrollpane, BorderLayout.CENTER);
      //this.pack();
    } // setGUI


  // createTable
  public JTable createTable() {
    // Create a model of the data.
        TableModel dataModel = new AbstractTableModel() {

            public int getColumnCount() {
              return names.length;
            }
            public int getRowCount() {
              return liste.size();
            }

            public Object getValueAt(int row, int col) {
              Student std = liste.get(row);
              Item  it;
              switch (col) {
                case 0: return new Item(std.getVorname(),(std.getActivate()&1)==1 );
                case 1: return new Item(std.getNachname(),(std.getActivate()&2)==2 );
                case 2: return new Item(Integer.toString(std.getMatrNummer()),    (std.getActivate()&4)==4 );
                case 3: return new Item(std.getUNummer(),(std.getActivate()&8)==8 );
                case 4: return new Item(std.getFarbe(),(std.getActivate()&16)==16 );
                default : return "XXXXXX";
              } // case

             }

            // The default implementations of these methods in
              // AbstractTableModel would work, but we can refine them.
            public String getColumnName(int column) {
              return names[column];
            }
            public Class getColumnClass(int c) {
              return getValueAt(0, c).getClass();
            }
            public boolean isCellEditable(int row, int col) {
              return true;
            }
            public void setValueAt(Object aValue, int row, int column) {
              Student std = liste.get(row);
              switch( column ) {
                case 0: std.setVorname( (String) aValue );
					break;
                case 1: std.setNachname( (String) aValue );
					break;
                case 2: //std.setMatrNummer( aValue );
					break;
                case 3: std.setUNummer( (String) aValue );
					break;
               default: System.out.println("Fehler in Case-Anweisung");
              }
            }
         };

     JTable table = new JTable(dataModel);
     table.setFont( new Font("Arial", Font.BOLD, 18) );

     DefaultTableCellRenderer numberColumnRenderer
          = new DefaultTableCellRenderer() {
          public void setValue(Object value) {
              Item it;
              boolean bActivate;
              if (value instanceof Item) {
                it = (Item) value;
                bActivate = it.activate;
                if (bActivate)
                  System.out.println("true "+it.Name);
                else
                  System.out.println("false    "+it.Name);
              }
              else {
                bActivate=false;
                System.out.println("xx");
              }
              // cellValue = (value instanceof Number) ? ((Number)value).intValue() : 0;

              if (bActivate) {
                //setForeground(Color.black);
                setBackground(Color.red);
              }
              else {
                setBackground(Color.white);
              }

              setText((value == null) ? "" : value.toString());
            }
           };

            // numberColumnRenderer.setHorizontalAlignment(JLabel.RIGHT);
            // numbersColumn.setPreferredWidth(110);
     for (int jj=0; jj<names.length; jj++) {
        TableColumn numbersColumn = table.getColumn( names[jj] );
        numbersColumn.setCellRenderer(numberColumnRenderer);
     }  // for jj

     return table;
  } // createTable


     // Eintragen
    private void setdata() {
      Student data;

      data = new Student("Mller","Kai", 4722, "U12345","Yellow", 0);
        liste.add(data);

      data = new Student( "Meyer","Uwe", 4712, "U12345","Red", 0);
        liste.add(data);

      data = new Student( "Schmidt","Petra", 4714, "U12325","Blue", 3);
        liste.add(data);

      data = new Student( "Brian","Adams", 6714, "U13325","Pink",0);
        liste.add(data);

      data = new Student( "Hold","Toni", 6614, "U13345","White", 6);
        liste.add(data);

      data = new Student( "Boll","Toni", 6613, "U13345","Maroon", 0);
        liste.add(data);

      data = new Student( "Seneca","Toni", 6314, "U13341","Gray", 0);
        liste.add(data);

      data = new Student( "Kredel","Helmut", 1613, "U23345","Phthalo Blue", 0);
        liste.add(data);


      data = new Student( "Brunl","Thomas", 1623, "U23315","Maroon", 2);
        liste.add(data);
      data = new Student( "Doug","Lea", 2613, "U11345","Blue", 0);
        liste.add(data);
      data = new Student( "Rauber","Rnger", 1612, "U23344","Red", 0);
        liste.add(data);
      data = new Student( "Walrath","Kathy", 1613, "U23345","Green", 0);
        liste.add(data);
      data = new Student( "Weber","Harald", 1613, "U23345","Black", 0);
        liste.add(data);

    }


    public static void main(String[] args) {
      Tabelle06 frame = new Tabelle06();
      frame.setVisible(true);
    }

}

// 1 = Vorname
// 2 = Nachname
// 4 = matrikelnummer
// 8 = UNummer
class Item {
    public String Name;
    public boolean activate;

    public Item(String Name, boolean activate) {
      this.Name = Name;
      this.activate = activate;
    }

    public String toString() {
      return Name;
    }
}

class Student {
    private String name;
    private String vorname;
    private int matrNummer;
    private String uNummer;
    private String farbe;

    private int activate;

    public Student() {
    }

    public int getColumns() {
      return 5;
    }

    public Student( Student std) {
      name = std.name;
      vorname = std.vorname;
      matrNummer = std.matrNummer;
      uNummer = std.uNummer;
      farbe = std.farbe;
      activate = std.activate;
    }

    public Student( String name, String vorname, int matrNummer,    String uNummer, String farbe, int activate) {
      this.name = name;
      this.vorname = vorname;
      this.matrNummer = matrNummer;
      this.uNummer = uNummer;
      this.farbe = farbe;
      this.activate = activate;
    }


    public int getActivate() {
       return activate;
    }

   public String getNachname() {
     return name;
   }
   public void setNachname(String Name) {
     this.name = Name;
   }


   public String getVorname() {
     return vorname;
   }
   public void setVorname(String Vorname) {
     this.vorname = vorname;
   }

   public int getMatrNummer() {
     return matrNummer;
   }
   public void setMatrNummer(int MatrNummer) {
     this.matrNummer = matrNummer;
   }


   public String getUNummer() {
     return uNummer;
   }
   public void setUNummer(String UNummer) {
     this.uNummer = uNummer;
   }


   public String getFarbe() {
     return farbe;
   }
   public void setFarbe(String Farbe) {
     this.farbe = farbe;
   }

}  // Student


